import React, {useEffect, useState} from "react"; 
import Layout from "../../public/components/layout";
import styles from '../../public/components/layout.module.css'; 
import archives from '../../public/components/Archives.module.css'; 
import ForgetPassword from "../../public/components/forgotpassword.module.css";
import { doc, getDocs, collection, getDoc } from "firebase/firestore"; 
import { db } from "../configs/firebase-config"; 
import { useRouter } from "next/router";


export default function Archives(){ 
const [building,setBuilding] = useState(''); 
const [floor,setFloor] = useState(''); 
const [floorarr,setFloorarr] = useState([]) 
const[loading, setLoading] = useState(true); 
const[chooseval,setVal] = useState(""); 
const[allmap, setAllmap] = useState([]); 
const[resetarr,setResetarr] = useState([]); 
const router = useRouter(); 
function removeButton(){ 
	console.log("Called"); 
	console.log(resetarr); 
	for(let p = 0;p<resetarr.length;p++){ 
		const Buttonid = document.getElementById(resetarr[p]); 
		Buttonid.style.display = 'none'; 
	}
}



const getallinfo = async() => { 
	try{
	const docref = collection(db,"users"); 
	const snapshot = await getDocs(docref); 
	let goodarray = []; 
	snapshot.forEach((ledoc)=> { 
		if(!['Emails', 'Messages', 'Comptes'].includes(ledoc.id) ){
		goodarray.unshift(ledoc.id); 
		console.log(ledoc.id);}
	})
	setFloorarr(goodarray); 
	
	return goodarray; 
} 
	catch(error){ 
		console.error(error); 
	}

	finally{ 
		setLoading(false); 
	}
}

const getButton = async(event)=>{ 
	event.preventDefault(); 
	let Building = event.target.value
	const Lebuild = document.getElementById("ArchivedesMessages")
	const docref2 = doc(db,"users",Building); 
	const snapshot2 = await getDoc(docref2); 
	const floorArr = snapshot2.data(); 
	setResetarr(Object.keys(floorArr)); 
	console.log(snapshot2.data()); 
	
	for(let i = 0;i<Object.keys(floorArr).length;i++){ 
		const Button = document.createElement("button")
		Button.setAttribute('id', Object.keys(floorArr)[i]) 
		Button.setAttribute('value',Object.keys(floorArr)[i]) 
		Button.classList.add(styles.button); 
		Button.innerHTML = Object.keys(floorArr)[i];  
		Lebuild.appendChild(Button); 
		
	}

	for(let i = 0;i<floorarr.length;i++){ 
		const floorid = document.getElementById(floorarr[i])
		floorid.style.display = "none"; 
	}
	
	setBuilding(Building); 
	
}

const seeMessages = async(event) => { 
	event.preventDefault(); 
	const showEverything = document.getElementById("Showornot"); 
	showEverything.style.display = "inline"
	let Floor = event.target.value; 
	let thestr = ""; 
	console.log(Floor); 
	const docref = doc(db,"users",building); 
	const snapshot = await getDoc(docref); 
	const arr = await snapshot.data()[Floor]; 
	console.log(snapshot.data()[Floor]);
	const PID = document.getElementById("impmes"); 
	const Thediv = document.getElementById("Showthis"); 
	
	for(let u = 0;u<Object.keys(arr).length;u++){ 
		const Anarr = Object.keys(arr);
		const anli = document.createElement('li'); 
		anli.setAttribute("id",anli[u])
		anli.textContent = Anarr[u]; 
		anli.style.backgroundColor = "grey"
		console.log(Anarr);  
		const gettheAnarr = arr[Anarr[u]];
		console.log(gettheAnarr, "g"); 
		PID.appendChild(anli); 
	for(let i = 0; i<gettheAnarr.length;i++){ 
		const newli = document.createElement("ul"); 
		thestr += gettheAnarr[i] + "\n"; 
		newli.textContent = thestr; 
		if(["There is a local power outage.", "There is construction nearby.", "Please open your windows.", "Please close your windows."].includes(thestr.split("\n")[0])){ 
			Thediv.appendChild(newli); 
		}
		else{
		PID.appendChild(newli);
		} 
		
		thestr = ""; 
		
	}

	
}

removeButton(); 
	
	

	
	
}

function contact(){ 
    router.push('https://www.och-lco.ca/contact-us/')
}

useEffect(()=>{ 
	const arrayfonc = getallinfo(); 
	setFloorarr(arrayfonc)
},[]) 





return(
<html lang="fr" >
	<Layout>
<head>
	<meta charset="UTF-8"></meta>
	<title>Historique de messages - Logement Communautaire Ottawa</title>
	
</head>
<div className={ForgetPassword.container}>
        <img src="https://mma.prnewswire.com/media/1252012/Soci_t__canadienne_d_hypoth_ques_et_de_logement_Le_plus_grand_in.jpg?p=facebook" alt="Logo" className={ForgetPassword.img}></img>
        <div className={ForgetPassword.line}></div>
        <button className={ForgetPassword.contact} onClick={contact}>Contact</button>
    </div>
<body>
	<header>
		
		<h1 className={styles.bigheader}>Historique de messages</h1>
	</header>

	 <form  onClick={getButton} style={{position:"relative",display:"grid",rowGap:15}}>
		<button  value = {floorarr[0]} id = {floorarr[0]} className={styles.button} >{floorarr[0]}</button>
		<button  value = {floorarr[1]} id = {floorarr[1]} className={styles.button}>{floorarr[1]}</button>
		<button  value = {floorarr[2]} id = {floorarr[2]}className={styles.button}>{floorarr[2]}</button>
		<button  value = {floorarr[3]} id = {floorarr[3]}className={styles.button}>{floorarr[3]}</button>
		<button  value = {floorarr[4]} id = {floorarr[4]}className={styles.button}>{floorarr[4]}</button>
		<button  value = {floorarr[5]} id = {floorarr[5]}className={styles.button}>{floorarr[5]}</button> 

		</form>

		<button id = "back" className={styles.back}>Back</button>

	<form id = "ArchivedesMessages" onClick={seeMessages} style={{position:"relative",display:"grid"}}>
	<div className={archives.container} style = {{display:"none", bottom: 30, position: "relative"}} id = "Showornot">
		
		<div className={archives.category}>
			<h2>High priority messages</h2>
			<div className={archives.message} id = "impmes">
				<div id = "submes"></div>
                
			</div>
        </div>
        <div className={archives.category} id = "ShowOthers">
            <h2>Other messages</h2>
            <div className={archives.message} id = "Showthis">
                
                
            </div>
        </div>
        </div>
	</form>
	
	
        </body>
		</Layout>
        </html>
);
}